package net.customware.license.atlassian;

import com.atlassian.license.LicenseType;
import net.customware.license.support.simple.SimpleLicenseParam;

public abstract class AtlassianLicenseParam extends SimpleLicenseParam {

    public AtlassianLicenseParam() {
    }

    public AtlassianLicenseParam(boolean lockable) {
        super(lockable);
    }

    public abstract LicenseType getLicenseType(int id);

    /**
     * Initialises the parameters to use the system preferences by default. May
     * be overridden in the {@link #init()} method by calling
     * {@link #requireLicensePerServer()} or
     * {@link #setPreferences(java.util.prefs.Preferences)}.
     */
    @Override
    protected void preInit() {
        requireLicensePerServer();
    }

    protected abstract void requireLicensePerServer();
}
